Attribute VB_Name = "MdlCutObject"
Option Explicit
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CreateRoundRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Public Declare Function CreateEllipticRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function SetWindowRgn Lib "User32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long

Public Const RGN_COPY = 5
Public Const RGN_AND = 1
Public Const RGN_XOR = 3
Public Const RGN_OR = 2
Public Const RGN_MIN = RGN_AND
Public Const RGN_MAX = RGN_COPY
Public Const RGN_DIFF = 4


Dim str$
Dim splRGN_File() As String

Public Sub ResetAll()
Erase splRGN_File()
End Sub

Public Function GetMaxLoadRGN() As Long
On Error GoTo Errors

GetMaxLoadRGN = UBound(splRGN_File) - 1

Exit Function
Errors:
GetMaxLoadRGN = -1
End Function


Public Function GetRegionFF(IndexOfRegions As Integer) As Long
Dim lSkinRgn As Long
Dim lRgn As Long
Dim i As Long

Dim splRGN_List() As String
Dim splRGN() As String

lSkinRgn = CreateRectRgn(0, 0, 0, 0)

splRGN_List() = Split(splRGN_File(IndexOfRegions), ";")

For i = LBound(splRGN_List) To UBound(splRGN_List) - 1

 splRGN() = Split(splRGN_List(i), ".")
 
lRgn = CreateRectRgn(CLng(splRGN(0)), CLng(splRGN(1)), CLng(splRGN(2)), CLng(splRGN(1)) + 1)

 CombineRgn lSkinRgn, lSkinRgn, lRgn, RGN_OR
DeleteObject lRgn

Next

GetRegionFF = lSkinRgn

Erase splRGN_List
Erase splRGN
End Function

Public Function LoadRGNFormFile(File_RGN As String) As Long
On Error GoTo Errors
Dim ff As Long

ff = FreeFile

Open File_RGN For Binary Access Read As ff

 str = String(LOF(ff), Chr(0))
 
  Get #ff, , str
  
 Close #ff
 
splRGN_File() = Split(str, vbCrLf)
  
Exit Function
Errors:
LoadRGNFormFile = Err.Number

End Function

Public Function lGetRegion(Pic As Object, lBackColor As Long) As Long
Dim lSkinRgn As Long
Dim lStart As Long
Dim lX As Long
Dim lY As Long
Dim lHeight As Long
Dim lWidth As Long

Dim ff As Long
ff = FreeFile

With Pic
    lHeight = .ScaleHeight
    lWidth = .ScaleWidth
    For lX = 0 To lHeight - 1
        lY = 0
        Do While lY < lWidth
            Do While lY < lWidth And GetPixel(.hDC, lY, lX) = lBackColor
                lY = lY + 1
            Loop
            If lY < lWidth Then
                lStart = lY
                Do While lY < lWidth And GetPixel(.hDC, lY, lX) <> lBackColor
                    lY = lY + 1
                Loop
                If lY > lWidth Then lY = lWidth
                If str = "" Then
               str = lStart & "." & lX & "." & lY & ";"
                Else
               str = str & lStart & "." & lX & "." & lY & ";"
                End If
            End If
        Loop
    Next
End With

ff = FreeFile
Open App.Path & "\RGN.txt" For Append As #ff
Print #ff, str
Close #ff
str = ""
End Function

Public Sub UseCutRng(Region As Long, hwnd As Long)
 SetWindowRgn hwnd, Region, True
End Sub

